﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;
using System.IO;
using System.Text.RegularExpressions;

namespace BlindSolveSync
{
    class AnsvrCygwin
    {
        string cygwinpath;
        string str_fitsfile;
        //double pixelsize;
        //double bin;
        public bool solved {get; set; }

        public double ra_result {get; set; }
        public double dec_result {get; set; }

        public AnsvrCygwin()
        {
            str_fitsfile = @"C:\\CCD Commander\\AllSkyPlateSolve.FIT";
            cygwinpath = @"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp";
            ra_result = 0.0;
            dec_result = 0.0;
            solved = false;
        }

        public bool Solve(string pathfilename, double ra, double dec, double arcsecpixel_min, double arcsecpixel_max, int radius=0, int timeout=0)
        {
            //OPMERKING: radius in degrees, timeout in seconds

            //First delete all the files in /tmp
            try
            {
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.axy"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.axy");
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.corr"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.corr");
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.match"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.match");
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.new"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.new");
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.rdls"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.rdls");
                //DEBUG:
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.solved"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.solved");
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.wcs"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.wcs");
                //END DEBUG
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve-indx.png"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve-indx.png");
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve-indx.xyls"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve-indx.xyls");
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve-ngc.png"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve-ngc.png");
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve-objs.png"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve-objs.png");
                //DEBUG:
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.FIT"))
                    File.Delete(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.FIT");
                //END  DEBUG


            }
            catch (Exception e)
            {
                Console.WriteLine("ERROR: error in deleting file");
                Console.WriteLine("DEBUG: ioexception: " + e.Message);
                Console.WriteLine("DEBUG: stacktrace: " + e.StackTrace);
            }


            //Copy file to cygwin temp location
            string str_cygwinfile = cygwinpath + @"\AllSkyPlateSolve.FIT";
            try
            {
                if (File.Exists(str_fitsfile))
                {
                    File.Copy(str_fitsfile, str_cygwinfile, true);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("ERROR: error in copying file AllSkyPlateSolve.FIT to Cygwin");
                Console.WriteLine("DEBUG: ioexception: " + e.Message);
                Console.WriteLine("DEBUG: stacktrace: " + e.StackTrace);
                return false;
            }

            //solve the field
            try
            {
                if (File.Exists(str_cygwinfile))
                {
                    using (Process p = new Process())
                    {
                        // set start info
                        p.StartInfo = new ProcessStartInfo("cmd.exe")
                        {
                            RedirectStandardInput = true,
                            UseShellExecute = false,
                            WorkingDirectory = @"C:\"
                        };

                        // event handlers for output & error
                        p.OutputDataReceived += p_OutputDataReceived;
                        p.ErrorDataReceived += p_ErrorDataReceived;

                        // start process
                        
                        p.Start();
                        
                        // send command to its input
                        //  -l timeoutseconds
                        //  -5 radiusdegrees
                        //p.StandardInput.Write(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\bin\bash.exe--login - c '/usr/bin/solve-field -p -O -U none -B none -R none -M none -N none -C cancel--crpix -center -z 2 --objs 100 -u arcsecperpix -L 3.5 -H 3.5 /tmp /AllSkyPlateSolve.FIT'" + p.StandardInput.NewLine);

                        string solvecommand;
                        solvecommand = @"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\bin\bash.exe --login -c '/usr/bin/solve-field -O /tmp/AllSkyPlateSolve.FIT'";
                        if (radius==0)
                        {
                            solvecommand = @"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\bin\bash.exe --login -c '/usr/bin/solve-field -O -l "+timeout+@" /tmp/AllSkyPlateSolve.FIT'";
                        }
                        if (timeout == 0)
                        {
                            solvecommand = @"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\bin\bash.exe --login -c '/usr/bin/solve-field -O -5 " + radius + @" /tmp/AllSkyPlateSolve.FIT'";
                        }
                        if ((timeout != 0) && (radius != 0))
                        {
                            //in bijna alle gevallen...
                            solvecommand = @"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\bin\bash.exe --login -c '/usr/bin/solve-field -p -O -U none -B none -R none -M none -N none -C cancel --crpix-center --objs 100 -u arcsecperpix -L "+arcsecpixel_min+" -H "+arcsecpixel_max+" -l " + timeout+" -5 " + radius + @" /tmp/AllSkyPlateSolve.FIT'";
                        }

                        //DEBUG:
                        Console.WriteLine("INFO: solvecommand: " + solvecommand);

                        p.StandardInput.Write(solvecommand + p.StandardInput.NewLine);
                        //p.StandardInput.Write("exit");
                        p.StandardInput.Close();
                        p.StandardInput.Dispose();
                        //wait
                        p.WaitForExit();
                        p.Close();
                        p.Dispose();
                        //Console.Clear();
                    }
                }
                else
                {
                    Console.WriteLine("STOP: File does not exist: " + str_cygwinfile);
                    return false;
                }

            }
            catch (Exception e)
            {
                Console.WriteLine("ERROR: in astrometry.net: "+e);
                return false;
            }
            //% LOCALAPPDATA %\cygwin_ansvr\bin\bash.exe--login - c "/usr/bin/solve-field -p -O -U none -B none -R none -M none -N none -C cancel --crpix-center -z 2 --objs 100 -u arcsecperpix -L 1.3752 -H 1.5199 /tmp/stars.fit"


            if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.solved"))
            {
                solved = true;
                return true;
            }
            else
            {
                //Console.WriteLine("ERROR: AllSkyPlateSolve.solved does not exist.  This means the field was not solved.");
                solved = false;
                return false;
            }
            
        }

        static void p_ErrorDataReceived(object sender, DataReceivedEventArgs e)
        {
            Process p = sender as Process;
            if (p == null)
                return;
            //Console.WriteLine(e.Data);
        }

        static void p_OutputDataReceived(object sender, DataReceivedEventArgs e)
        {
            Process p = sender as Process;
            if (p == null)
                return;
            //Niet nodig output naar scherm te schrijven, output staat desgewenst in de ansvr_watch_log
            //Console.WriteLine(e.Data);
        }

        public bool ExtractWCS()
        {
            try
            {
                if (File.Exists(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.wcs"))
                {
                    StreamReader reader = File.OpenText(@"C:\Users\C-Boy\AppData\Local\cygwin_ansvr\tmp\AllSkyPlateSolve.wcs");
                    string line;
                    while ((line = reader.ReadLine()) != null)
                    {
                        Regex r = new Regex(" +");
                        string [] splitString = r.Split(line);

                        string ra_detected="";
                        string dec_detected="";

                        for (int i=0; i<splitString.Count(); i++)
                        {
                            //Debug:
                            //Console.WriteLine("info: String "+i+":" +splitString[i]);
                            if (splitString[i] == "CRVAL1")
                            {
                                ra_detected=splitString[i + 2];
                            }
                            if (splitString[i] == "CRVAL2")
                            {
                                dec_detected = splitString[i + 2];
                            }
                        }

                        if ((ra_detected != "") && (dec_detected != ""))
                        {
                            ra_result = Double.Parse(ra_detected);
                            //OPGELET: resultaat is in graden, niét in uren
                            //converteer dus in uren:
                            ra_result = ra_result / 15.0;
                            dec_result = Double.Parse(dec_detected);
                            Console.WriteLine("INFO: RA detected:"+ra_result+" - DEC:"+dec_result);
                            return true;
                        }
                        else
                        {
                            Console.WriteLine("ERROR: could not parse RA & DEC results");
                            return false;
                        }

                    }
                    return false;
                    
                }
                else
                {
                    Console.WriteLine("ERROR: AllSkyPlateSolve.wcs does not exist");
                    return false;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("DEBUG: ioexception: " + e.Message);
                Console.WriteLine("DEBUG: stacktrace: " + e.StackTrace);
                return false;
            }

        }

    }
}