﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Web;
using Newtonsoft.Json;
using System.IO;


namespace BlindSolveSync
{
    //NOG NIET IN ORDE !!!
    class AnsvrWebApi
    {
        string url = "http://127.0.0.1:8080/";
        string fits = "C:\\CCD Commander\\AllSkyPlateSolve.FIT";
        string sessionid { get; set; }
        string[] jobs;
        public string processing_started { get; set;  }
        public string processing_finished { get; set;  }
        public string jobid { get; set; }
        public string jobstatus { get; set; }

        public bool solutionfound { get; set; }
        public bool sessionidfound { get; set; }
        public bool jobidfound { get; set; }

        public bool uploadsuccess { get; set; }

        public int statuscode { get; set; }
        public string LastMessage { get; set; }

        double ra_start { get; set; }
        double dec_start { get; set;  }
        double rad { get; set; }

        double ra_result { get; set; }
        double dec_result { get; set;  }

        public int timeout { get; set; }


        public AnsvrWebApi()
        {
            sessionid = "";
            jobid = "";
            jobstatus = "";
            processing_started = "";
            processing_finished = "";
            LastMessage = "AnsvrWebApi initialised.";
            solutionfound = false;
            sessionidfound = false;
            jobidfound = false;
            uploadsuccess = false;
            timeout = 100;              //standaard value voor httpclient
            
            ra_result = 999.9;
            dec_result = 999.9;

            //Task.Run(async () => { await Login(); });
            //Task.Factory.StartNew(() =>Login());

            //Login();
            Login().Wait();


        }

        ~AnsvrWebApi()
        {

        }

        /*public void Login()
        {
            
        }*/

        public void Solve(double startra, double startdec, double radius, string filename, double pixelscale, double bin, int time_out)
        {
            ra_start = startra;
            dec_start = startdec;
            fits = filename;
            rad = radius;
            timeout = time_out;

            //if (jobidfound)
            
            Upload(pixelscale, bin).Wait();
            Submissions().Wait();
            jobidfound = false;
            for (int i = 0; i < jobs.Count(); i++)
            {
                jobid = jobs[i];            //Get last job
                if (jobid != "")
                {
                    jobidfound = true;
                }
            }
        }

        public bool IsBusySolving()
        {
            if (processing_finished == "")
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        public bool FoundSolution()
        {
            JobStatus().Wait();
            if (jobstatus == "success")
            {
                return true;
            }
            if (jobstatus == "failure")
            {
                return false;
            }
            if (jobstatus == "error")
            {
                return false;
            }
            else
            {
                return false;
            }

        }

        private async Task Login()
        {
            using (var httpClient = new HttpClient())
            {
               
                //string URI = "http://nova.astrometry.net/api/login";
                // string myParameters = "request-json=%7B%22apikey%22%3A+%22ckylhfaafccqhumf%22%7D";
                //JsonObject obj = new JsonObject();
                //JsonObject jsonObject = getLoginJSON(apikey);
                // String input = "&request-json=" + jsonObject.ToString();
                string input = "apikey";
                Console.WriteLine("INFO10: login started");

                httpClient.BaseAddress = new Uri(url);
                httpClient.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
                HttpContent contentPost = new StringContent(input, Encoding.UTF8, "application/x-www-form-urlencoded");
                Console.WriteLine("INFO16: voorpostasync");
                using (var response = await httpClient.PostAsync("api/login", contentPost))
                {
                    Console.WriteLine("INFO15: napostasync");
                    string responseData = await response.Content.ReadAsStringAsync();
                    Console.WriteLine("INFO14: " + responseData);
                    if (response.IsSuccessStatusCode)
                    {
                        var result = JsonConvert.DeserializeObject<Dictionary<string, string>>(responseData);
                        sessionid = result["session"];
                        LastMessage = "Login successful.  SessionID=" + sessionid;
                        Console.WriteLine("INFO11: Login successful.  SessionID=" + sessionid);
                    }
                    else
                    {
                        LastMessage = "Login NOT successful.";
                        Console.WriteLine("INFO12: Login successful.  SessionID=" + sessionid);
                    }
                    //var serializer = new JavaScriptSerializer();
                    //var serializer=new
                    //var serializer = new JsonSerializer();
                    //var result2 = serializer.Deserialize<Dictionary<string, string>>(responseData);  //e.g. http://procbits.com/2011/04/21/quick-json-serializationdeserialization-in-c


                    //return session;
                    
                }
                httpClient.Dispose();
            }



        }

        private async Task Upload(double pixelscale, double bin)
        {
            //                string URI = "http://nova.astrometry.net/api/upload";
            //JsonObject obj = new JsonObject();
            //JsonObject jsonObject = getUploadJson(session);
            //String input = jsonObject.ToString();  // was &json-request...
            //string baseAddress = "http://nova.astrometry.net/api/upload";

            double totalscale = pixelscale * bin;

            //string jsonstring = "{'session': '"+sessionid+"','allow_commercial_use': 'd','allow_modifications': 'd','publicly_visible': 'y','scale_units': 'arcsecperpix','scale_type': 'ev','scale_est': "+totalscale+",'scale_err': 100.0}";
            //jsonstring = JsonConvert.ToString(jsonstring);

            var configs = new[]
            {
                new { session = sessionid, allow_commercial_use = "d", allow_modifications = "d", publicly_visible = "y", scale_units = "arcsecperpix", scale_type = "ev", scale_est = totalscale, scale_err = 100.0}
            };

            string jsonstring = JsonConvert.SerializeObject(configs);

            //string jsonstring = "kaka";

            //jsonstring = jsonstring.Replace(" ", "");
            //jsonstring = jsonstring.Replace("\n", "");

            Console.WriteLine("INFO55: in upload, jsonstrincg: " + jsonstring);

            using (var httpClient = new HttpClient())
            {
                using (var content = new MultipartFormDataContent())
                {

                    var fileContent = new ByteArrayContent(File.ReadAllBytes(fits));
                    httpClient.BaseAddress = new Uri(url);
                    //httpClient.Timeout = System.TimeSpan.Parse((timeout*1000).ToString());
                    httpClient.DefaultRequestHeaders.TryAddWithoutValidation("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8");
                    //   httpClient.DefaultRequestHeaders.TryAddWithoutValidation("file", "\"file\"");
                    //content.Add(new StringContent(jsonObject.ToString(), Encoding.UTF8, "text/plain"), "&request-json");//wasd   "application/x-www-form-urlencoded"
                    content.Add(new StringContent(jsonstring, Encoding.UTF8, "text/plain"), "&request-json");//wasd   "application/x-www-form-urlencoded"
                    Console.WriteLine("INFO51");
                    var contentFile = new StringContent("filename="+fits, Encoding.UTF8, "application/octet-stream"); content.Add(contentFile, "file");
                    Console.WriteLine("INFO52: "+jsonstring);
                    Console.WriteLine("INFO521: " + fits);
                    //using (var response = await httpClient.PostAsync("api/upload", content))
                    using (var response = await httpClient.PostAsync("api/upload", content))
                    {
                        Console.WriteLine("INFO53: "+response);
                        //string responseData = await response.Content.ReadAsStringAsync();
                        //richTextBox1.Text = response.ToString();
                        if (response.IsSuccessStatusCode)
                        {
                            string responseData = await response.Content.ReadAsStringAsync();
                            LastMessage = "Upload successful5.  ResponseData=" + responseData;
                            Console.WriteLine("INFO400: Upload successful.  ResponseData=" + responseData);
                            var result = JsonConvert.DeserializeObject<Dictionary<string, string>>(responseData);
                            string status = result["status"];
                            Console.WriteLine("INFO401: status: " +status);
                            if (status == "error")
                            {
                                uploadsuccess = false;
                            }
                        }
                        else
                        {
                            LastMessage = "Upload NOT successful.  Jsonstring: " + jsonstring;
                            Console.WriteLine("INFO410: Upload NOT successful.  Jsonstring: " + jsonstring);
                        }
                        Console.WriteLine("INFO402: endupload");

                        //richTextBox1.AppendText("sucess!");

                        //richTextBox1.AppendText(responseData.ToString());
                    }
                }
                httpClient.Dispose();
            }
        }

        private async Task Submissions()
        {
            //                string URI = "http://nova.astrometry.net/api/upload";
            //JsonObject obj = new JsonObject();
            //JsonObject jsonObject = getUploadJson(session);
            //String input = jsonObject.ToString();  // was &json-request...
            //string baseAddress = "http://nova.astrometry.net/api/upload";

            //string jsonstring = "zet jsonstring hier";

            using (var httpClient = new HttpClient())
            {
                //using (var content = new MultipartFormDataContent())
                //{

                //var fileContent = new ByteArrayContent(File.ReadAllBytes(filename));
                Console.WriteLine("INFO40: in submissions");
                httpClient.BaseAddress = new Uri(url);
                httpClient.DefaultRequestHeaders.TryAddWithoutValidation("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8");
                //   httpClient.DefaultRequestHeaders.TryAddWithoutValidation("file", "\"file\"");
                //content.Add(new StringContent(jsonObject.ToString(), Encoding.UTF8, "text/plain"), "&request-json");//wasd   "application/x-www-form-urlencoded"
                //content.Add(new StringContent(jsonstring, Encoding.UTF8, "text/plain"), "&request-json");//wasd   "application/x-www-form-urlencoded"

                //var contentFile = new StringContent("filename=" + filename, Encoding.UTF8, "application/octet-strem"); //content.Add(contentFile, "file");

                using (var response = await httpClient.PostAsync("api/submissions/" + sessionid, null))
                {
                    //richTextBox1.Text = response.ToString();
                    if (response.IsSuccessStatusCode)
                    {
                        string responseData = await response.Content.ReadAsStringAsync();
                        Console.WriteLine("INFO41: " + responseData);
                        var result = JsonConvert.DeserializeObject<Dictionary<string, string>>(responseData);
                        //jobs = result["jobs"];
                        string jobs2 = result["jobs"];
                        processing_started = result["processing_finished"];
                        processing_finished = result["processing_finished"];
                        LastMessage = "Submissions successful.  Jobs: " + jobs2.ToString()+" ProcessingStarted: "+processing_started+" ProcessingFinished:"+processing_finished;
                        Console.WriteLine("INFO31: Submissions successful.  Jobs: " + jobs2.ToString() + " ProcessingStarted: " + processing_started + " ProcessingFinished:" + processing_finished);
                    }
                    else
                    {
                        LastMessage = "Submissions NOT successful.";
                        Console.WriteLine("INFO32: Submissions NOT successful");
                    }
                }

                //richTextBox1.AppendText("sucess!");

                //richTextBox1.AppendText(responseData.ToString());
                httpClient.Dispose();
                //}
            }
        }
 
        private async Task JobStatus()
        {
            //                string URI = "http://nova.astrometry.net/api/upload";
            //JsonObject obj = new JsonObject();
            //JsonObject jsonObject = getUploadJson(session);
            //String input = jsonObject.ToString();  // was &json-request...
            //string baseAddress = "http://nova.astrometry.net/api/upload";

            //string jsonstring = "zet jsonstring hier";

            using (var httpClient = new HttpClient())
            {
                //using (var content = new MultipartFormDataContent())
                //{

                //var fileContent = new ByteArrayContent(File.ReadAllBytes(filename));
                httpClient.BaseAddress = new Uri(url);
                httpClient.DefaultRequestHeaders.TryAddWithoutValidation("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8");
                //   httpClient.DefaultRequestHeaders.TryAddWithoutValidation("file", "\"file\"");
                //content.Add(new StringContent(jsonObject.ToString(), Encoding.UTF8, "text/plain"), "&request-json");//wasd   "application/x-www-form-urlencoded"
                //content.Add(new StringContent(jsonstring, Encoding.UTF8, "text/plain"), "&request-json");//wasd   "application/x-www-form-urlencoded"
                Console.WriteLine("INFO80: in jobstatus");
                //var contentFile = new StringContent("filename=" + filename, Encoding.UTF8, "application/octet-strem"); //content.Add(contentFile, "file");

                using (var response = await httpClient.PostAsync("api/jobs/" + jobid, null))
                {
                    //richTextBox1.Text = response.ToString();
                    if (response.IsSuccessStatusCode)
                    {
                        string responseData = await response.Content.ReadAsStringAsync();
                        Console.WriteLine("INFO81: " + responseData);
                        var result = JsonConvert.DeserializeObject<Dictionary<string, string>>(responseData);
                        jobstatus = result["status"];                   //success ; failure
                        LastMessage = "JobStatus successful.  Jobstatus=" + jobstatus;
                        Console.WriteLine("INFO84: " + jobstatus);
                    }
                    else
                    {
                        LastMessage = "JobStatus NOT successful.";
                        Console.WriteLine("INFO85");
                    }

                    //richTextBox1.AppendText("sucess!");

                    //richTextBox1.AppendText(responseData.ToString());
                }
                httpClient.Dispose();
                 //}
            }
        }

        public async Task Calibration(string sess, string filename)
        {
            //                string URI = "http://nova.astrometry.net/api/upload";
            //JsonObject obj = new JsonObject();
            //JsonObject jsonObject = getUploadJson(session);
            //String input = jsonObject.ToString();  // was &json-request...
            //string baseAddress = "http://nova.astrometry.net/api/upload";

            //string jsonstring = "zet jsonstring hier";

            using (var httpClient = new HttpClient())
            {
                //using (var content = new MultipartFormDataContent())
                //{
                Console.WriteLine("INFO62: in calibration");
                //var fileContent = new ByteArrayContent(File.ReadAllBytes(filename));
                httpClient.DefaultRequestHeaders.TryAddWithoutValidation("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8");
                //   httpClient.DefaultRequestHeaders.TryAddWithoutValidation("file", "\"file\"");
                //content.Add(new StringContent(jsonObject.ToString(), Encoding.UTF8, "text/plain"), "&request-json");//wasd   "application/x-www-form-urlencoded"
                //content.Add(new StringContent(jsonstring, Encoding.UTF8, "text/plain"), "&request-json");//wasd   "application/x-www-form-urlencoded"

                //var contentFile = new StringContent("filename=" + filename, Encoding.UTF8, "application/octet-strem"); //content.Add(contentFile, "file");

                using (var response = await httpClient.PostAsync(url + "/api/jobs/" + jobid + "/calibration", null))
                {
                    //richTextBox1.Text = response.ToString();
                    if (response.IsSuccessStatusCode)
                    {
                        string responseData = await response.Content.ReadAsStringAsync();
                        Console.WriteLine("INFO63: " + responseData);
                        var result = JsonConvert.DeserializeObject<Dictionary<string, string>>(responseData);
                        string epoch= result["epoch"];
                        string parity = result["parity"];
                        string pixscale = result["pixscale"];
                        string radius = result["radius"];
                        string ra = result["ra"];
                        string orientation = result["orientation"];
                        string dec = result["dec"];
                        ra_result = Double.Parse(ra);
                        dec_result = Double.Parse(dec);
                        LastMessage = "Calibration is successful.  Epoch=" + epoch + " Parity=" + parity + " Pixscale=" + pixscale + " Radius=" + radius + " RA=" + ra + " Orientation= " + orientation + "DEC=" + dec;
                    }
                    else
                    {
                        LastMessage = "Calibration is NOT successful.";
                    }

                    //jobs = result["jobs"];
                    //richTextBox1.AppendText("sucess!");

                    //richTextBox1.AppendText(responseData.ToString());
                }
                httpClient.Dispose();
                //}
            }
        }


    }
}
