﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace BlindSolveSync
{
    public sealed class Logger
    {

        private static Logger _logger;
        private static readonly object _synlock = new object();

        private string logpath="C:\\CCD Commander\\Logs";
        private string logfilename="BlindSolveSync.txt";

        StreamWriter w;

        private Logger()
        {
            try
            {
                logfilename = "BlindSolveSync_" + DateTime.Now.ToString("yy") + DateTime.Now.ToString("MM") + DateTime.Now.ToString("dd") + ".log";

                w = File.AppendText(logpath + "\\" + logfilename);
                Console.WriteLine("Path of logfile: " + logpath + "\\" + logfilename);
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: " + e.ToString());
            }

        }

        public static Logger GetLogger()
        {
            try
            {
                if (_logger == null)
                {
                    lock (_synlock)
                    {
                        if (_logger == null)
                        {
                            _logger = new Logger();
                        }
                    }
                }

                return _logger;
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: " + e.ToString());
                return _logger;
            }
        }

        public void WriteLine(string message)
        {
            try
            {
                Console.WriteLine(message);
                w.WriteLine("{0}-{1}  {2}", DateTime.Now.ToShortDateString(), DateTime.Now.ToLongTimeString(), message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: " + e.ToString());
            }
 
        }

        public void Write(string message)
        {
            try
            {
                Console.Write(message);
                w.Write(message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: " + e.ToString());
            }

        }
    }
}
